<%@ Import Namespace="myComponents" %>

<Script Runat="Server">

Sub Button_Click( s As Object, e As EventArgs )
  Dim myBizObject As New BizObject

  If isValid Then
  Try
    myBizObject.CheckOrder( _
     txtCustomer.Text, _
     dropProduct.SelectedItem.Text, _
     txtUnitPrice.Text, _
     txtQuantity.Text, _
     dropState.SelectedItem.Text )
  Catch expException As Exception
    lblError.Text = expException.Message
  End Try
  End If
End Sub

</Script>

<html>
<head><title>OrderForm.aspx</title></head>
<body>

<form Runat="Server">

<h2>Enter an Order:</h2>

<asp:Label
  id="lblError"
  ForeColor="Red"
  Font-Bold="True"
  EnableViewState="False"
  Runat="Server" />

<p>
Customer Name:
<br>
<asp:TextBox
  id="txtCustomer"
  Runat="Server" />

<asp:RequiredFieldValidator
  ControlToValidate="txtCustomer"
  Text="You must enter a customer name!"
  Runat="Server" />

<p>
Product:
<br>
<asp:ListBox
  id="dropProduct"
  Runat="Server">
  <asp:ListItem Text="Hair Dryer" />
  <asp:ListItem Text="Shaving Cream" />
  <asp:ListItem Text="Electric Comb" />
</asp:ListBox>

<asp:RequiredFieldValidator
  ControlToValidate="dropProduct"
  Text="You must select a product!"
  Runat="Server" />

<p>
Unit Price:
<br>
<asp:TextBox
  id="txtUnitPrice"
  Runat="Server" />

<asp:RequiredFieldValidator
  ControlToValidate="txtUnitPrice"
  Text="You must enter a unit price!"
  Runat="Server" />


<p>
Quantity:
<br>
<asp:TextBox
  id="txtQuantity"
  Runat="Server" />

<asp:RequiredFieldValidator
  ControlToValidate="txtQuantity"
  Text="You must enter a quantity!"
  Runat="Server" />

<asp:CompareValidator
  ControlToValidate="txtQuantity"
  Text="Quantity must be a number!"
  Operator="DataTypeCheck"
  Type="Integer"
  Runat="Server" />

<p>
Customer State:
<br>
<asp:DropDownList
  id="dropState"
  Runat="Server">
  <asp:ListItem Text="California" />
  <asp:ListItem Text="Nevada" />
  <asp:ListItem Text="Washington" />
</asp:DropDownList>

<p>
<asp:Button
  Text="Place Order"
  OnClick="Button_Click"
  Runat="Server" />

</form>

</body>
</html>
