<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">

Sub Page_Load
  If Not IsPostBack Then
    Dim conNorthwind As SqlConnection
    Dim cmdSelect As SqlCommand
    Dim dtrCategories As SqlDataReader

    conNorthwind = New SqlConnection( "Server=localhost;UID=sa;PWD=secret;Database=Northwind" )
    cmdSelect = New SqlCommand( "Select CategoryID, CategoryName From Categories", conNorthwind )
    conNorthwind.Open()
    dtrCategories = cmdSelect.ExecuteReader()

    dropCategories.DataSource = dtrCategories
    dropCategories.DataTextField = "CategoryName"
    dropCategories.DataValueField = "CategoryID"
    dropCategories.DataBind()

    dropCategories.Items.Insert( 0, New ListItem( "none selected", -1 ) )

    dtrCategories.Close()
    conNorthwind.Close()
  End If
End Sub


Sub BindProducts( intCatID As Integer )
  Dim conNorthwind As SqlConnection
  Dim cmdSelect As SqlCommand
  Dim strSelect As String
  Dim dtrProducts As SqlDataReader

  conNorthwind = New SqlConnection( "Server=localhost;UID=sa;PWD=secret;Database=Northwind" )
  conNorthwind.Open()

  strSelect = "Select ProductName, UnitPrice From Products Where CategoryID=@catID"
  cmdSelect = New SqlCommand( strSelect, conNorthwind )
  cmdSelect.Parameters.Add( "@catID", intCatID )
  dtrProducts = cmdSelect.ExecuteReader()

  rptProducts.DataSource = dtrProducts
  rptProducts.DataBind()

  dtrProducts.Close()
  conNorthwind.Close()
End Sub


Sub dropCategories_SelectedIndexChanged( s As Object, e As EventArgs )
  Dim intCatID As Integer

  intCatID = dropCategories.SelectedItem.Value
  If intCatID <> -1 Then
    BindProducts( intCatID )
  End If
End Sub

</Script>

<html>
<head><title>MasterDetail.aspx</title></head>
<body>
<form Runat="Server">

<b>Select Category:</b>
<asp:DropDownList
  ID="dropCategories"
  AutoPostBack="True"
  OnSelectedIndexChanged="dropCategories_SelectedIndexChanged"
  Runat="Server"/>

<p>

<asp:Repeater
  ID="rptProducts"
  EnableViewState="False"
  Runat="Server">

<ItemTemplate>
<li><%# Container.DataItem( "ProductName" ) %>
- <%# String.Format( "{0:c}", Container.DataItem( "UnitPrice" ) ) %>
</ItemTemplate>

</asp:Repeater>

</form>
</body>
</html>
