<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<script runat=server>

void Page_Load(Object sender , EventArgs e) 
{
	DataSet dstNorthwind; 
	SqlConnection conNorthwind;
	SqlDataAdapter dadNorthwind;
	DataColumn dcolProductCount;

	//Grab the Categories and Products table
	dstNorthwind = new DataSet();
	conNorthwind = new SqlConnection( @"Server=localhost;Integrated Security=SSPI;Database=Northwind" );
	dadNorthwind = new SqlDataAdapter( "Select * From Categories", conNorthwind );
	conNorthwind.Open();
	dadNorthwind.Fill( dstNorthwind, "Categories" );
	dadNorthwind.SelectCommand = new SqlCommand( "Select * From Products", conNorthwind );
	dadNorthwind.Fill( dstNorthwind, "Products" );
	conNorthwind.Close();

	//Add Parent/Child Relationship
	dstNorthwind.Relations.Add( "catprods", dstNorthwind.Tables[ "Categories" ].Columns[ "CategoryID" ], dstNorthwind.Tables[ "Products" ].Columns[ "CategoryID" ] );

	//Add the aggregate column
	dcolProductCount = new DataColumn (("ProductCount"), System.Type.GetType("System.Decimal"));
	dcolProductCount.Expression = "Count( Child.ProductID )";
	dstNorthwind.Tables[ "Categories" ].Columns.Add( dcolProductCount );

	//Bind to the DataGrid
	dgrdNorthwind.DataSource = dstNorthwind;
	dgrdNorthwind.DataMember = "Categories";
	dgrdNorthwind.DataBind();
}
</Script>

<html>
<head><title>AggregateColumn.aspx</title></head>
<body>

<asp:DataGrid
  ID="dgrdNorthwind"
  Runat="Server" />

</body>
</html>
