<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<script runat=server>
void Button_Click(Object sender , EventArgs e) 
{
	DataSet dstEmployees;
	SqlConnection conNorthwind;
	SqlDataAdapter dadEmployees;
	DataView dvwEmployees;
	Object[] arrValues = new Object[2];
	int intEmployeeIndex;

	//Get cached DataView
	  
	dvwEmployees = (DataView)Cache["Employees"];
	if (dvwEmployees == null)
	{
		dstEmployees = new DataSet();
		conNorthwind = new SqlConnection( @"Server=localhost;Integrated Security=SSPI;Database=Northwind" );
		dadEmployees = new SqlDataAdapter( "Select * From Employees", conNorthwind );
		dadEmployees.Fill( dstEmployees, "Employees" );
		dvwEmployees = dstEmployees.Tables["Employees"].DefaultView;
		dvwEmployees.Sort = "LastName, FirstName";
		Cache["Employees"] = dvwEmployees;
	}

	//Find the employee
	arrValues[0] = txtLastName.Text;
	arrValues[1] = txtFirstName.Text;
	if (dvwEmployees == null)
		intEmployeeIndex=-1;
	else
		intEmployeeIndex = dvwEmployees.Find( arrValues );
	if (intEmployeeIndex > -1 ) 
	{
		lblName.Text = txtLastName.Text + ", " + txtFirstName.Text;
		lblPhone.Text = dvwEmployees[ intEmployeeIndex ].Row[ "HomePhone" ].ToString();
		lblNotes.Text = dvwEmployees[ intEmployeeIndex ].Row[ "Notes" ].ToString();
	}
	else
		lblError.Text = "Employee Not Found!";
 }

</Script>

<html>
<head><title>CacheEmployees.aspx</title></head>
<body>

<h2>Employee Directory</h2>

<form Runat="Server">
<b>First Name:</b>
<asp:TextBox
  ID="txtFirstName"
  Runat="Server" />
<p>
<b>Last Name:</b>
<asp:TextBox
  ID="txtLastName"
  Runat="Server" />
<asp:Button
  Text="Find!"
  OnClick="Button_Click"
  Runat="Server" />
<hr>
<asp:Label
  ID="lblError"
  ForeColor="Red"
  EnableViewState="False"
  Runat="Server" />
<asp:Label
  ID="lblName"
  EnableViewState="False"
  Runat="Server" />
<p>
<asp:Label
  ID="lblPhone"
  EnableViewState="False"
  Runat="Server" />
<p>
<asp:Label
  ID="lblNotes"
  EnableViewState="False"
  Runat="Server" />
</form>

</body>
</html>
