<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<script runat=server>

 void Page_Load(Object sender , EventArgs e) 
 {
	if (!IsPostBack) 
    {
		//Bind to datagrid
		dgrdProducts.DataSource = GetProducts();
		dgrdProducts.DataBind();
	}
}

public DataView GetProducts()
{
	DataSet dstProducts;
	SqlConnection conNorthwind;
	SqlDataAdapter dadProducts;
	DataView dvwProducts = Cache["Products"] as DataView;
	if (dvwProducts == null)
	{
		dstProducts = new DataSet();
		conNorthwind = new SqlConnection( @"Server=localhost;Integrated Security=SSPI;Database=Northwind" );
		dadProducts = new SqlDataAdapter( "Select * from Products", conNorthwind );
		dadProducts.Fill( dstProducts, "Products" );
		dvwProducts = dstProducts.Tables["Products"].DefaultView;
		Cache["Products"] = dvwProducts;
	}
	return dvwProducts;
 } 

void dgrdProducts_SortCommand( Object sender , DataGridSortCommandEventArgs e )
{
	DataView dvwProducts;
	//Sort DataView
	dvwProducts = GetProducts();
	dvwProducts.Sort = e.SortExpression;

	//Rebind to DataGrid
	dgrdProducts.DataSource = dvwProducts;
	dgrdProducts.DataBind();
 }
</Script>

<html>
<head><title>CacheProducts.aspx</title></head>
<body>

<form Runat="Server">
<asp:DataGrid
  ID="dgrdProducts"
  AllowSorting="True"
  OnSortCommand="dgrdProducts_SortCommand"
  Runat="Server" />
</form>

</body>
</html>