using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;

public class ProductsHandler: IHttpHandler {
	public void ProcessRequest( HttpContext objContext ) {
		int intProductID;
		SqlConnection conNorthwind;
		string  strSelect;
		SqlCommand cmdSelect;
		SqlDataReader dtrProducts;

		intProductID = GetProductID( objContext.Request.Path );
		conNorthwind = new SqlConnection(@"Server=localhost;Integrated Security=SSPI;Database=Northwind" );
		strSelect = "Select ProductName, UnitPrice From Products" + " Where ProductID=@ProductID";
		cmdSelect = new SqlCommand( strSelect, conNorthwind );
		cmdSelect.Parameters.Add( "@ProductID", intProductID );
		conNorthwind.Open();
		dtrProducts = cmdSelect.ExecuteReader( CommandBehavior.SingleRow );
		if ( dtrProducts.Read() ) {
			objContext.Response.Write( "<h2>Product Name:</h2>" );
			objContext.Response.Write( dtrProducts["ProductName"] );
			objContext.Response.Write( "<h2>Product Price:</h2>" );
			objContext.Response.Write( String.Format( "{0:c}", dtrProducts["UnitPrice"] ) );
		}
		conNorthwind.Close();
	}

	bool IHttpHandler.IsReusable {
		get {return true;}
	}

	int GetProductID( string  strPath ) {
		int intCounter;
		string strNumbers = String.Empty;

		for ( intCounter = 0 ; intCounter <= strPath.Length -1; ) {
			if ( char.IsDigit( strPath[intCounter] ) ) {
				strNumbers += strPath[intCounter];
			}
		} 
		if ( strNumbers != null ) {
			return Convert.ToInt32(strNumbers);
		} else {
			return -1;
		}
	}
}
