<%@ Page Language="C#" %>
<script language="C#" runat=server>

public static CacheItemRemovedCallback onRemove;

void ItemRemoved( string  strItemKey, object objItemValue, CacheItemRemovedReason objRemovedReason ) 
{
  string  strLogEntry;

  strLogEntry = "Item with value " + objItemValue.ToString() ;
  strLogEntry = " removed at " + System.DateTime.Now.ToString( "T" );
  strLogEntry = " because of " + objRemovedReason.ToString();
  if ( Application[ "CacheLog" ] == null )
  {
   Application[ "CacheLog" ] = new ArrayList();
  }
  //Application[ "CacheLog" ].Add( "strLogEntry" );
  //Beep();
}

void btnAddCache_Click( object s, EventArgs e )
{
	onRemove =  new CacheItemRemovedCallback( ItemRemoved );
    Cache.Insert( "myItem", txtNewValue.Text, null,  DateTime.Now.AddSeconds( 10 ), Cache.NoSlidingExpiration, CacheItemPriority.High, onRemove );
}

void btnRemoveCache_Click( object s, EventArgs e )
{
  Cache.Remove( "myItem" );
}

void Page_PreRender( object s, EventArgs e )
{
  dgrdCacheLog.DataSource = Application[ "CacheLog" ];
  dgrdCacheLog.DataBind();
}


</Script>

<html>
<head><title>CacheCallback.aspx</title></head>
<body>
<form Runat="Server">

<h2>Cache Log</h2>
<asp:DataGrid
  ID="dgrdCacheLog"
  CellPadding="8"
  Runat="Server" />
<p>
<asp:TextBox
  id="txtNewValue"
  Runat="Server" />
<p>
<asp:Button
  id="btnAddCache"
  Text="Add To Cache!"
  OnClick="btnAddCache_Click"
  Runat="Server" />

<asp:Button
  id="btnRemoveCache"
  Text="Remove From Cache!"
  OnClick="btnRemoveCache_Click"
  Runat="Server" />

<asp:Button
  Text="Refresh Page!"
  Runat="Server" />

</form>
</body>
</html>
