<Script Runat="Server">

Public Shared onRemove As CacheItemRemovedCallback

Sub ItemRemoved( _
  strItemKey As String, _
  objItemValue As Object, _
  objRemovedReason As CacheItemRemovedReason )

  Dim strLogEntry As String

  strLogEntry = "Item with value " & objItemValue.ToString() 
  strLogEntry &= " removed at " & Now.ToString( "T" )
  strLogEntry &= " because of " & objRemovedReason.ToString()
  If Application( "CacheLog" ) Is Nothing Then
    Application( "CacheLog" ) = New ArrayList
  End If
  Application( "CacheLog" ).Add( strLogEntry )
  Beep
End Sub

Sub btnAddCache_Click( s As Object, e As EventArgs )
    onRemove =  New CacheItemRemovedCallback( AddressOf ItemRemoved )
    Cache.Insert( "myItem", _
                   txtNewValue.Text, _
                   Nothing, _
                   Now.AddSeconds( 10 ), _
                   Cache.NoSlidingExpiration, _
                   CacheItemPriority.High, _
                   onRemove )
End Sub

Sub btnRemoveCache_Click( s As Object, e As EventArgs )
  Cache.Remove( "myItem" )
End Sub

Sub Page_PreRender( s As Object, e As EventArgs )
  dgrdCacheLog.DataSource = Application( "CacheLog" )
  dgrdCacheLog.Databind()
End Sub

</Script>

<html>
<head><title>CacheCallback.aspx</title></head>
<body>
<form Runat="Server">

<h2>Cache Log</h2>
<asp:DataGrid
  ID="dgrdCacheLog"
  CellPadding="8"
  Runat="Server" />
<p>
<asp:TextBox
  id="txtNewValue"
  Runat="Server" />
<p>
<asp:Button
  id="btnAddCache"
  Text="Add To Cache!"
  OnClick="btnAddCache_Click"
  Runat="Server" />

<asp:Button
  id="btnRemoveCache"
  Text="Remove From Cache!"
  OnClick="btnRemoveCache_Click"
  Runat="Server" />

<asp:Button
  Text="Refresh Page!"
  Runat="Server" />

</form>
</body>
</html>
