<%@ Import Namespace="Services" %>

<Script runat="Server">

Const strUsername As String = "Steve"
Const strPassword As String = "Secret"

Sub Page_Load
  Dim objSecureService As SecureService
  Dim objServiceTicket As ServiceTicket
  Dim objAuthHeader As AuthHeader

  objSecureService = New SecureService
  objServiceTicket = Session( "ServiceTicket" )

  ' Check for ticket existence
  If objServiceTicket Is Nothing Then
    objServiceTicket = objSecureService.Login( strUsername, strPassword )
    Session( "ServiceTicket" ) = objServiceTicket
  End If

  ' Check for ticket expiration
  If objServiceTicket.Expiration < DateTime.Now Then
    objServiceTicket = objSecureService.Login( strUsername, strPassword )
    Session( "ServiceTicket" ) = objServiceTicket
  End If

  ' Call the web service
  If objServiceTicket.IsAuthenticated Then
    objAuthHeader = New AuthHeader
    objAuthHeader.SessionKey = objServiceTicket.SessionKey
    objSecureService.AuthHeaderValue = objAuthHeader
    lblLuckyNumber.Text = objSecureService.GetLuckyNumber()
  Else
    lblLuckyNumber.Text = "Invalid username or password!"
  End If
End Sub

</Script>

<html>
<head><title>TestSecureService.aspx</title></head>
<body>

<asp:Label
  id="lblLuckyNumber"
  EnableViewState="False"
  Runat="Server" />

</body>
</html>




