<%@ Page Language="C#" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.Xml.Serialization" %>

<Script runat="Server">

public class ShoppingCart {
  public string  Username;
  public string  CreditCardNumber;
  public CartItem[] CartItems;
}

public class CartItem {
  public string  ProductName;
  public Decimal ProductPrice;
}

void Page_Load (Object sender , EventArgs e){
   ShoppingCart objShoppingCart;
   StreamReader objStreamReader;
   XmlSerializer objXmlSerializer;

  // Retrieve XML File
  objStreamReader = File.OpenText( MapPath( "ShoppingCart.xml" ) );
  objXmlSerializer = new XmlSerializer( typeof( ShoppingCart ) );
  objShoppingCart = (ShoppingCart)objXmlSerializer.Deserialize( objStreamReader );
  objStreamReader.Close();

  // Display Shopping Cart
  txtUsername.Text = objShoppingCart.Username;
  txtCCnumber.Text = objShoppingCart.CreditCardNumber;
  foreach ( CartItem objItem in objShoppingCart.CartItems)
  {
    lblCart.Text += "<li>" + objItem.ProductName;
    lblCart.Text += "-" + objItem.ProductPrice.ToString( "c" );
  }
  
}

</Script>

<html>
<head><title>DeserializeXMLClass.aspx</title></head>
<body>
<form runat="Server">

Username:
<br><asp:Label 
  id="txtUsername" 
  runat="Server" />
<p>
Credit Card Number:
<br><asp:Label 
  id="txtCCnumber" 
  runat="Server" />
<p>
<asp:Label 
  id="lblCart" 
  Runat="Server" />

</form>
</body>
</html>
