<%@ Page Language="C#" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.Xml.Serialization" %>

<Script runat="Server">

public class ShoppingCart {
  public string Username;
  public string CreditCardNumber;
  public CartItem[] CartItems;
}

public class CartItem {
  public string ProductName;
  public decimal ProductPrice;
}

void Button_Click(object sender, EventArgs e) {
  ShoppingCart objShoppingCart;
  ArrayList colCartItems;
  CartItem objCartItem;
  StreamWriter objStreamWriter;
  XmlSerializer objXmlSerializer;
  
  // Create the Shopping Cart
  objShoppingCart = new ShoppingCart();
  objShoppingCart.Username = txtUsername.Text;
  objShoppingCart.CreditCardNumber = txtCCnumber.Text;
  colCartItems = new ArrayList();
  foreach (ListItem objItem in lstCart.Items) {
    objCartItem = new CartItem();
    objCartItem.ProductName = objItem.Text;
    objCartItem.ProductPrice = Decimal.Parse(objItem.Value);
    colCartItems.Add( objCartItem );
  }
  objShoppingCart.CartItems = (CartItem[])colCartItems.ToArray( typeof( CartItem ) );

  // Save to XML File
  objStreamWriter = File.CreateText( MapPath( "ShoppingCart.xml" ) );
  objXmlSerializer = new XmlSerializer( typeof( ShoppingCart ) );
  objXmlSerializer.Serialize( objStreamWriter, objShoppingCart );
  objStreamWriter.Close();
}
</Script>

<html>
<head><title>SerializeXMLClass.aspx</title></head>
<body>
<form runat="Server">

Username:
<br><asp:TextBox 
  id="txtUsername" 
  runat="Server" />
<p>
Credit Card Number:
<br><asp:TextBox 
  id="txtCCnumber" 
  runat="Server" />
<p>
<asp:ListBox
  id="lstCart"
  Runat="Server" >
<asp:ListItem Text="Bread" Value="12.34" />
<asp:ListItem Text="Milk" Value="1.99" />
<asp:ListItem Text="Beer" Value="19" />
</asp:ListBox>
<p>
<asp:Button 
  Text="Save!" 
  OnClick="Button_Click" 
  Runat="Server" />

</form>
</body>
</html>
