using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

namespace myControls {

	public class FeaturedControl : WebControl {

		private DataSet GetDataSet() {
			FeaturedService objService = new FeaturedService();
			return objService.GetFeatured();
		}

		protected override void RenderContents( HtmlTextWriter objTextWriter ) {
			DataSet dstDataSet;
			DataTable dtblDataTable;

			dstDataSet = Context.Cache["FeaturedProducts"] as DataSet;
			if (dstDataSet == null) {
				dstDataSet = GetDataSet();
				Context.Cache.Insert( "FeaturedProducts", dstDataSet, null, 
					DateTime.Now.AddMinutes(5), TimeSpan.Zero );
			}

			dtblDataTable = dstDataSet.Tables["Products"];
			foreach (DataRow drowRow in dtblDataTable.Rows) {
				objTextWriter.Write( "<li>" );
				objTextWriter.Write( drowRow["ProductName"] );
				objTextWriter.Write( " - " );
				objTextWriter.Write( String.Format("{0:c}", drowRow["UnitPrice"]) );
				objTextWriter.WriteLine( "<p>" );
			}
		}
	}
}