using System;
using System.Web;
using System.Web.UI;

namespace myControls {

	public class MultipleTemplatesTemplateItem : Control, INamingContainer {
		private int _dataItem;

		public MultipleTemplatesTemplateItem( int DataItem ) {
			_dataItem = DataItem;
		}

		public int DataItem {
			get {
				return _dataItem;
			}
			set {
				_dataItem = value;
			}
		}
	}


	[ParseChildren(true)] 
	public class MultipleTemplates : Control, INamingContainer {
		private ITemplate _itemTemplate;
		private ITemplate _alternatingItemTemplate;

		[TemplateContainer(typeof(MultipleTemplatesTemplateItem))]
		public ITemplate ItemTemplate {
			get {
				return _itemTemplate;
			}
			set {
				_itemTemplate = value;
			}
		}

		[TemplateContainer(typeof(MultipleTemplatesTemplateItem))]
		public ITemplate AlternatingItemTemplate {
			get {
				return _alternatingItemTemplate;
			}
			set {
				_alternatingItemTemplate = value;
			}
		}

		public override void DataBind() {
			EnsureChildControls();
			base.DataBind();
		}

		protected override void CreateChildControls() {
			MultipleTemplatesTemplateItem objTemplateItem;
			Controls.Clear();
			for (int i=0;i<=10;i++) {
				objTemplateItem = new MultipleTemplatesTemplateItem(i);

				if (Decimal.Remainder( i, 2 ) == 0) 
					ItemTemplate.InstantiateIn( objTemplateItem );
				else
					AlternatingItemTemplate.InstantiateIn( objTemplateItem );
    
				Controls.Add( objTemplateItem );
			}
		}
	}
}
