using System.Web;
using System.Web.UI;

namespace myControls {

	public class TemplateItem : Control, INamingContainer {

		private string  _dataItem;

		public TemplateItem( string DataItem ) {
			_dataItem = DataItem;
		}

		public string  DataItem {
			get {
				return _dataItem;
			}
			set {
				_dataItem = value;
			}
		}
	}

	[ParseChildren(true)]
	public class SimpleTemplate : Control, INamingContainer {

		private ITemplate _itemTemplate;
		private string  _text;

		public string  Text {
			get {
				return _text;
			}
			set {
				_text = value;
			}
		}

		[TemplateContainer(typeof(TemplateItem))] 
		public ITemplate ItemTemplate {
			get {
				return _itemTemplate;
			}
			set {
				_itemTemplate = value;
			}
		}

		public override void DataBind() {
			EnsureChildControls();
			base.DataBind();
		}

		protected override void CreateChildControls() {
			TemplateItem objTemplateItem;
    
			Controls.Clear();
			objTemplateItem = new TemplateItem( this.Text );
			ItemTemplate.InstantiateIn( objTemplateItem );
			Controls.Add( objTemplateItem );
		}
	}
}
