<%@ Page Language="C#" %>
<!-- #INCLUDE Virtual="~/site/includes/header.aspx" -->
<script language="C#" runat=server>

int intJobID;
 string  strUsername;

void Page_Load(Object sender , EventArgs e) 
{
   string  strConString;
   SqlConnection conJobs;
   SqlCommand cmdSelect;
   SqlDataReader dtrDataReader;

  // get Job ID
  intJobID = System.Convert.ToInt32(Request.QueryString[ "id" ]);

  // Create Apply Link
  lnkApply.NavigateUrl =  string .Format("~/site/password/apply.aspx?id={0}", intJobID );

  // get Job From Database
  strConString = ConfigurationSettings.AppSettings[ "constring"];
  conJobs = new SqlConnection( strConString );
  cmdSelect = new SqlCommand( "getJob", conJobs );
  cmdSelect.CommandType = CommandType.StoredProcedure;
  cmdSelect.Parameters.Add( "@jobid", intJobID );
  conJobs.Open();
    dtrDataReader = cmdSelect.ExecuteReader();
    if ( dtrDataReader.Read() ) {
      ctrlHeader.PageTitle = dtrDataReader[ "Job_briefdesc" ].ToString();
      lblJobBriefDesc.Text = dtrDataReader[ "job_briefdesc" ].ToString();
      lblJobFullDesc.Text = dtrDataReader[ "job_fulldesc" ].ToString();
      lblJobEntryDate.Text = dtrDataReader[ "job_entrydate" ].ToString();
      strUsername = dtrDataReader[ "job_username" ].ToString();
    }
    dtrDataReader.Close();
    // get Job Applications
    if ( Page.User.Identity.IsAuthenticated)
    if (Page.User.Identity.Name.ToLower() == strUsername.ToLower() )
    {
      cmdSelect.CommandText = "getApplications";
      dtrDataReader = cmdSelect.ExecuteReader();
      dgrdApplications.DataSource = dtrDataReader;
      dgrdApplications.DataBind();
      dtrDataReader.Close();
    }
  conJobs.Close();
  lnkJobUsername.Text =  string .Format( "{0} ({0}.aspx)", strUsername );
  lnkJobUsername.NavigateUrl = string .Format( "~/{0}.aspx", strUsername );
}
void UpdatePage( object s, EventArgs e )
{
  pnlUpdatePage.Visible = true  ;
  txtJobFullDesc.Text = lblJobFullDesc.Text;
  txtJobBriefDesc.Text = lblJobBriefDesc.Text;
  pnlViewPage.Visible = false;
}

void Page_PreRender(Object sender , EventArgs e) 
{
  // Check if This is Users Page
  if ( ctrlUserLinks.IsAuthenticated )
  {
    if ( Page.User.Identity.Name.ToLower() == strUsername.ToLower() )
    {
      pnlUserIntro.Visible = true;
      pnlViewApplications.Visible = true;
    } 
  }
  else 
  {
    pnlUserIntro.Visible = false;
    pnlViewPage.Visible = true;
    pnlUpdatePage.Visible = false;
    pnlViewApplications.Visible = false;
  }
}

void SaveJob( object s, EventArgs e )
{
   SqlConnection conJobs;
   string  strConString;
   SqlCommand cmdUpdate;

  if ( Page.User.Identity.IsAuthenticated )
  {
    strConString = ConfigurationSettings.AppSettings[ "constring" ];
    conJobs = new SqlConnection( strConString );
    cmdUpdate = new SqlCommand( "updateJob", conJobs );
    cmdUpdate.CommandType = CommandType.StoredProcedure;
    cmdUpdate.Parameters.Add( "@jobID", intJobID );
    cmdUpdate.Parameters.Add( "@briefdesc", txtJobBriefDesc.Text );
    cmdUpdate.Parameters.Add( "@fulldesc", txtJobFullDesc.Text );
    conJobs.Open();
    cmdUpdate.ExecuteNonQuery();
    conJobs.Close();
    pnlViewPage.Visible = true;
    lblJobBriefDesc.Text = txtJobBriefDesc.Text;
    lblJobFullDesc.Text = txtJobFullDesc.Text;
    ctrlHeader.PageTitle = txtJobBriefDesc.Text;
    pnlUpdatePage.Visible = false;
  }
}

</Script>

<myControls:Header
  ID="ctrlHeader"
  Runat="Server" />
<form runat="Server">
<myControls:UserLinks
  ID="ctrlUserLinks"
  Runat="Server" />
<br clear="all">
<asp:Panel
  ID="pnlUserIntro"
  Visible="False"
  CssClass="UserInfoPanel"
  Runat="Server">
Hi <%=strUsername%>! Welcome to your job page!
<br>
If you would like to update the contents of
this page, 
<asp:LinkButton
  Text="click here."
  OnClick="UpdatePage"
  Runat="Server" />
</asp:Panel>

<%-- View Page Panel --%>
<asp:Placeholder
  ID="pnlViewPage"
  Runat="Server">
<asp:Label
  ID="lblJobBriefDesc"
  CssClass="TopHeading"
  Runat="Server" />
<table cellspacing=5 cellpadding=5 border=0>
<tr><td valign="top" width="500" bgcolor="#eeeeee">
<asp:Label
  ID="lblJobFullDesc"
  Runat="Server" />
</asp:Placeholder>

<%-- Update Job Panel --%>
<asp:Placeholder
  ID="pnlUpdatePage"
  Visible="False"
  Runat="Server">
<table cellspacing=10 border=0>
<tr><td valign="top" width="500">
<b>Job Brief Description</b>
<br>
<asp:TextBox
  ID="txtJobBriefDesc"
  Columns="50"
  CssClass="formfield"
  runat="Server" />
<p>
<b>Job Full Description</b>
<br>
<asp:TextBox
  ID="txtJobFullDesc"
  TextMode="Multiline"
  Columns="60"
  Rows="10"
  CssClass="formfield"
  Runat="Server" />
<br>
<asp:Button
  Text="Save!"
  OnClick="SaveJob"
  Runat="Server" />
</asp:Placeholder>

<p>
<b>Listed On</b>
<br>
<asp:Label
  ID="lblJobEntryDate"
  Runat="Server" />
<p>
<b>Listed By</b>
<br>
<asp:HyperLink
  ID="lnkJobUsername"
  Runat="Server" />

</td><td valign="top">

<asp:HyperLink
  ID="lnkApply"
  Text="Apply"
  Runat="Server" />
<br>
Click here to apply for this job

<asp:Panel
  ID="pnlViewApplications"
  CssClass="UserInfoPanel"
  Visible="False"
  Runat="Server">
<b>View Applications</b>
<br>
<asp:DataGrid
  ID="dgrdApplications"
  GridLines="None"
  font-size="10pt"
  AutoGenerateColumns="False"
  ShowHeader="False"
  Cellpadding="3"
  Runat="Server">
<Columns>
<asp:BoundColumn
  DataField="app_entrydate"
  DataFormatString="{0:m}" />
<asp:HyperLinkColumn
  DataTextField="app_from"
  DataNavigateUrlField="app_id" 
  DataNavigateUrlFormatString="~/site/password/viewapplication.aspx?id={0}"/>
</Columns>
</asp:DataGrid>
</asp:Panel>

</td></tr>
</table>
</form>
<myControls:Footer
  Runat="Server" />