<!-- #INCLUDE Virtual="~/site/includes/header.aspx" -->

<Script language="C#" runat="Server">

void Page_Load(object sender, EventArgs e) {
  string strReturnUrl;

  if (!IsPostBack) {
    strReturnUrl = Request.QueryString["ReturnUrl"];
    lnkRegister.NavigateUrl = 
      String.Format( 
        "~/site/register.aspx?ReturnUrl={0}", 
        Server.UrlEncode( strReturnUrl ) 
     );
  }
}

void Button_Click( object sender, EventArgs e ) {
  if (IsValid) {
	switch (VerifyPassword( txtUsername.Text, txtPassword.Text )) {
		case 0:
			FormsAuthentication.RedirectFromLoginPage( txtUsername.Text, chkPersist.Checked );
			break;
		case 1:
			lblError.Text = "You did not enter a registered username";
			break;
		case 2:
			lblError.Text = "You did not enter a valid password";
			break;
	}
  }
}

int VerifyPassword( string strUsername, string strPassword ) {
  string strConString;
  SqlConnection conJobs;
  SqlCommand cmdVerify;
  SqlParameter parmReturn;
  
  strConString = ConfigurationSettings.AppSettings["constring"];
  conJobs = new SqlConnection( strConString );
  cmdVerify = new SqlCommand( "VerifyPassword", conJobs );
  cmdVerify.CommandType = CommandType.StoredProcedure;
  parmReturn = cmdVerify.Parameters.Add( "@return", SqlDbType.Int );
  parmReturn.Direction = ParameterDirection.ReturnValue;
  cmdVerify.Parameters.Add( "@username", strUsername );
  cmdVerify.Parameters.Add( "@password", strPassword );
  conJobs.Open();
    cmdVerify.ExecuteNonQuery();
  conJobs.Close();
  return (int)cmdVerify.Parameters["@return"].Value;
}

</Script>

<myControls:Header
  pageTitle="Please Login"
  Runat="Server" />
<form runat="Server">

<table cellpadding="10" cellspacing="15"
  border="0">
<tr><td>
<h3>Login</h3>
<asp:Label
  ID="lblError"
  EnableViewState="False"
  forecolor="red"
  font-bold="True"
  runat="Server" />
<p>
<b>Username:</b>
<br>
<asp:TextBox
  ID="txtUsername"
  CssClass="formfield"
  runat="Server" />
<asp:RequiredFieldValidator
  ControlToValidate="txtUsername"
  Text="Required!"
  runat="Server" />
<p>
<b>Password:</b>
<br>
<asp:TextBox
  ID="txtPassword"
  TextMode="password"
  CssClass="formfield"
  runat="Server" />
<asp:RequiredFieldValidator
  ControlToValidate="txtPassword"
  Text="Required!"
  runat="Server" />
<p>
<asp:Button
  Text="Login!"
  OnClick="Button_Click"
  runat="Server" />
<p>
<asp:CheckBox
  ID="chkPersist"
  Checked="True" 
  runat="Server" />
Automatically remember me

</td><td valign="top">

<h3>Register</h3>
Are you a new user?
<p>
<asp:HyperLink
  ID="lnkRegister"
  Text="Click here to register!"
  runat="Server" />
<p>
It's free and it only takes a minute.
</td></tr>
</table>
</form>
<myControls:Footer
  runat="Server"/>