<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script language="C#" runat="Server">

void Page_Load(object sender, EventArgs e) {
  if (!IsPostBack) {
    dgrdNewJobs.DataSource = GetNewJobs();
    dgrdNewResumes.DataSource = GetNewResumes();
    DataBind();
    lblListingCount.Text = 
		String.Format( 
			"Over {0} jobs and {1} resumes listed!", 
			GetJobCount(), 
			GetResumeCount() 
		);
  }
}

DataSet GetNewJobs() {
	string strConString;
	SqlConnection conJobs;
	SqlDataAdapter dadJobs;
	DataSet dstJobs;
	
  dstJobs = Cache["NewJobs"] as DataSet;
  if (dstJobs == null) {
    // Ready Database Connection
    strConString = ConfigurationSettings.AppSettings["constring"];
    conJobs = new SqlConnection( strConString );
    dstJobs = new DataSet();
    // Get Newest 50 Jobs From Database
    dadJobs = new SqlDataAdapter( "getNewJobs", conJobs );
    dadJobs.SelectCommand.CommandType = CommandType.StoredProcedure;
    dadJobs.Fill( dstJobs, "NewJobs" );
    Cache["NewJobs"] = dstJobs;
  }
  return dstJobs;
}

DataSet GetNewResumes() {
	string strConString;
	SqlConnection conJobs;
	SqlDataAdapter dadResumes;
	DataSet dstResumes;
  
  dstResumes = Cache["NewResumes"] as DataSet;
  if (dstResumes == null) {
    // Ready Database Connection
    strConString = ConfigurationSettings.AppSettings["constring"];
    conJobs = new SqlConnection( strConString );
    dstResumes = new DataSet();
    // Get Newest 50 Resumes From Database
    dadResumes = new SqlDataAdapter( "getNewResumes", conJobs );
    dadResumes.SelectCommand.CommandType = CommandType.StoredProcedure;
    dadResumes.Fill( dstResumes, "NewResumes" );
    Cache["NewResumes"] = dstResumes;
  }
  return dstResumes;
}

int GetJobCount() {
	string strConString;
	SqlConnection conJobs;
	SqlCommand cmdSelect;
	int intJobCount=0;
  
  if (Cache["jobCount"] != null)
	intJobCount = (int)Cache["jobCount"];
  
  if (intJobCount == 0) {
    strConString = ConfigurationSettings.AppSettings["constring"];
    conJobs = new SqlConnection( strConString );
    cmdSelect = new SqlCommand( "getJobCount", conJobs );
    cmdSelect.CommandType = CommandType.StoredProcedure;
    conJobs.Open();
      intJobCount = (int)cmdSelect.ExecuteScalar();
    conJobs.Close();
    Cache.Insert( 
      "jobCount", 
       intJobCount,
       null, 
       DateTime.Now.AddMinutes( 10 ), 
       TimeSpan.Zero );
  }
  return intJobCount;
}

int GetResumeCount() {
	string strConString;
	SqlConnection conJobs;
	SqlCommand cmdSelect;
	int intResumeCount=0;
		  
	if (Cache["resumeCount"] != null)
		intResumeCount = (int)Cache["resumeCount"];
	if (intResumeCount == 0) {
		strConString = ConfigurationSettings.AppSettings["constring"];
		conJobs = new SqlConnection( strConString );
		cmdSelect = new SqlCommand( "getResumeCount", conJobs );
		cmdSelect.CommandType = CommandType.StoredProcedure;
		conJobs.Open();
		intResumeCount = (int)cmdSelect.ExecuteScalar();
		conJobs.Close();
		Cache.Insert( 
		"resumeCount", 
		intResumeCount, 
		null, 
		DateTime.Now.AddMinutes( 10 ), 
		TimeSpan.Zero );
	 }
	 return intResumeCount;
}

void NewJobsPage( object sender, DataGridPageChangedEventArgs e ) {
  dgrdNewJobs.CurrentPageIndex = e.NewPageIndex;  
  dgrdNewJobs.DataSource = GetNewJobs();
  dgrdNewJobs.DataBind();
}

void NewResumesPage( object sender, DataGridPageChangedEventArgs e ) {
  dgrdNewResumes.CurrentPageIndex = e.NewPageIndex;  
  dgrdNewResumes.DataSource = GetNewResumes();
  dgrdNewResumes.DataBind();
}

</Script>

<asp:Label
  ID="lblListingCount"
  CssClass="TopHeading"
  Runat="Server"/>
<p>
<b>Newest Jobs!</b>
<br>
<asp:DataGrid
  ID="dgrdNewJobs"
  AllowPaging="True"
  OnPageIndexChanged="NewJobsPage"
  PageSize="5"
  PagerStyle-HorizontalAlign="Right"
  PagerStyle-Font-Name="Georgia"
  GridLines="None"
  Cellspacing="4"
  AutoGenerateColumns="False"
  ShowHeader="False"
  Runat="Server">
<Columns>
<asp:BoundColumn
  DataField="job_entrydate"
  DataFormatString="{0:m}" />
<asp:HyperLinkColumn
  DataTextField="job_briefdesc"
  DataNavigateUrlField="job_id" 
  DataNavigateUrlFormatString="~/site/job.aspx?id={0}"/>
</Columns>
</asp:DataGrid>
<p>

<b>Newest Resumes!</b>
<br>
<asp:DataGrid
  ID="dgrdNewResumes"
  AllowPaging="True"
  OnPageIndexChanged="NewResumesPage"
  PageSize="5"
  PagerStyle-HorizontalAlign="Right"
  PagerStyle-Font-Name="Georgia"
  GridLines="None"
  Cellspacing="4"
  AutoGenerateColumns="False"
  ShowHeader="False"
  Runat="Server">
<Columns>
<asp:BoundColumn
  DataField="ul_entrydate"
  DataFormatString="{0:m}" />
<asp:HyperLinkColumn
  DataTextField="ul_briefdesc"
  DataNavigateUrlField="ul_username" 
  DataNavigateUrlFormatString="~/{0}.aspx"/>
</Columns>
</asp:DataGrid>
