<!-- #INCLUDE Virtual="/aspnetjobs/site/includes/header.aspx" -->

<Script runat="Server">

Dim strPageOwner As String

Sub Page_Load
  Dim conJobs As SqlConnection
  Dim strConString As String
  Dim cmdSelect As SqlCommand
  Dim dtrDataReader As SqlDataReader
  Dim blnIsResume As Boolean

  If Not IsPostBack Then
    ' Get Page Owner From Query String
    strPageOwner = Request.QueryString( "PageOwner" )
    ViewState( "PageOwner" ) = strPageOwner
 
   ' Build Enquire Link
    lnkEnquire.NavigateUrl = _
      String.Format( _
        "/aspnetjobs/site/password/enquire.aspx?id={0}", _
        strPageOwner )

    ' Get Page Info From Database
    strConString = ConfigurationSettings.AppSettings( "constring" )
    conJobs = New SqlConnection( strConString )
    cmdSelect = New SqlCommand( "getUserPage", conJobs )
    cmdSelect.CommandType = CommandType.StoredProcedure
    cmdSelect.Parameters.Add( "@username", strPageOwner )
    conJobs.Open()
    dtrDataReader = cmdSelect.ExecuteReader()
    If dtrDataReader.Read Then
      lblBriefDesc.Text = dtrDataReader( "ul_briefdesc" )
      lblFullDesc.Text = dtrDataReader( "ul_fulldesc" )
      blnIsResume = dtrDataReader( "ul_isresume" )
    Else
      Response.Redirect( "/aspnetjobs/default.aspx" )
    End If
    dtrDataReader.Close()

    ' Get Job List
    If Not blnIsResume Then
      cmdSelect.CommandText = "getJobs"
      dtrDataReader = cmdSelect.ExecuteReader()
      dgrdCurrentJobs.Datasource = dtrDataReader
      dgrdcurrentJobs.Databind()
      dtrDataReader.Close
      If dgrdCurrentJobs.Items.Count > 0 Then
        pnlCurrentJobs.Visible = True
      End If
    End If

    ' Get Enquiry List
    If IsPageOwner( strPageOwner ) Then
      cmdSelect.CommandText = "getEnquiries"
      dtrDataReader = cmdSelect.ExecuteReader()
      dgrdEnquiries.Datasource = dtrDataReader
      dgrdEnquiries.Databind()
      dtrDataReader.Close
    End If
    conJobs.Close()
  Else
    strPageOwner = Viewstate( "PageOwner" )
  End If

  ' Show Title As Brief Description
  ctrlHeader.PageTitle = lblBriefDesc.Text
End Sub

Sub Page_PreRender
  ' Check if This is User's Page
  If ctrlUserLinks.IsPageOwner( strPageOwner ) Then
    pnlUserIntro.Visible = True
    pnlViewEnquiries.Visible = True
  Else
    pnlUserIntro.Visible = False
    pnlUpdatePage.Visible = False
    pnlViewEnquiries.Visible = False
    pnlViewPage.Visible = True
  End If
End Sub

Sub UpdatePage( s As Object, e As EventArgs )
  pnlUpdatePage.Visible = True  
  txtBriefDesc.Text = lblBriefDesc.Text
  txtFullDesc.Text = lblFullDesc.Text
  pnlViewPage.Visible = False
End Sub

Sub SaveDescription( s As Object, e As EventArgs )
  Dim conJobs As SqlConnection
  Dim strConString As String
  Dim cmdUpdate As SqlCommand

  If ctrlUserLinks.IsPageOwner( strPageOwner ) Then
    strConString = ConfigurationSettings.AppSettings( "constring" )
    conJobs = New SqlConnection( strConString )
    cmdUpdate = New SqlCommand( "updateUserInfo", conJobs )
    cmdUpdate.CommandType = CommandType.StoredProcedure
    cmdUpdate.Parameters.Add( "@username", strPageOwner )
    cmdUpdate.Parameters.Add( "@briefdesc", txtBriefDesc.Text )
    cmdUpdate.Parameters.Add( "@fulldesc", txtFullDesc.Text )
    conJobs.Open()
      cmdUpdate.ExecuteNonQuery()
    conJobs.Close()
    pnlViewPage.Visible = True
    lblBriefDesc.Text = txtBriefDesc.Text
    lblFullDesc.Text = txtFullDesc.Text
    ctrlHeader.PageTitle = txtBriefDesc.Text
    pnlUpdatePage.Visible = False  
  End If
End Sub

Public Function IsPageOwner( PageOwner As String ) As Boolean
  If User.Identity.IsAuthenticated _
    And Page.User.Identity.Name.ToLower = strPageOwner.ToLower Then
      Return True
  Else
    Return False
  End If
End Function

</Script>

<myControls:Header
  ID="ctrlHeader"
  Runat="Server" />
<form runat="Server">

<myControls:UserLinks
  ID="ctrlUserLinks"
  Runat="Server" />
<br clear="all">

<%-- User Info Panel --%>
<asp:Panel
  ID="pnlUserIntro"
  Visible="False"
  CssClass="UserInfoPanel"
  Runat="Server">
Hi <%=strPageOwner %>! Welcome to your page!
<br>
If you would like to update the contents of
this page, 
<asp:LinkButton
  Text="click here"
  OnClick="UpdatePage"
  Runat="Server" />
</asp:Panel>

<%-- View Page Panel --%>
<asp:Placeholder
  ID="pnlViewPage"
  Runat="Server">
  <asp:Label
    ID="lblBriefDesc"
    CssClass="TopHeading"
    runat="Server"/>
<table cellspacing="5" cellpadding="5" border=0>
<tr><td valign="top" width="500" bgcolor="#eeeeee">
  <asp:Label
    ID="lblFullDesc"
    Runat="Server" />
</asp:Placeholder>

<%-- Update Page Panel --%>
<asp:Placeholder
  ID="pnlUpdatePage"
  Visible="False"
  Runat="Server" >
<table cellspacing=10 border=0>
<tr><td valign="top" width="500">
<b>Brief Description</b>
<br>
<asp:TextBox
  ID="txtbriefdesc"
  Columns="50"
  CssClass="formfield"
  Runat="Server" />
<p>
<b>Full Description</b>
<br>
<asp:TextBox
  ID="txtfulldesc"
  TextMode="Multiline"
  Columns="70"
  Rows="10"
  CssClass="formfield"
  Runat="Server" />
<br>
<asp:Button
  Text="Save!"
  OnClick="SaveDescription"
  Runat="Server" />
</asp:Placeholder>

</td><td valign="top">

<asp:HyperLink
  ID="lnkEnquire"
  Text="enquire"
  Runat="Server" />
<br>
Click here to request more information
about this individual or company
<p>
<asp:Panel
  ID="pnlViewEnquiries"
  CssClass="UserInfoPanel"
  Visible="False"
  Runat="Server">
<b>View Enquiries</b>
<br>
<asp:DataGrid
  ID="dgrdEnquiries"
  GridLines="None"
  font-size="10pt"
  AutoGenerateColumns="False"
  ShowHeader="False"
  Cellpadding="3"
  Runat="Server">
<Columns>
<asp:BoundColumn
  DataField="e_entrydate"
  DataFormatString="{0:m}" />
<asp:HyperLinkColumn
  DataTextField="e_from"
  DataNavigateUrlField="e_id" 
  DataNavigateUrlFormatString="/aspnetjobs/site/password/viewenquire.aspx?id={0}"/>
</Columns>
</asp:DataGrid>
</asp:Panel>

<asp:Panel
  ID="pnlCurrentJobs"
  Visible="False"
  Runat="Server">
<h3>Current Job Openings</h3>
<asp:DataGrid
  ID="dgrdCurrentJobs"
  AutoGenerateColumns="False"
  GridLines="None"
  Cellpadding="4"
  AlternatingItemStyle-BackColor="aliceblue"
  ShowHeader="False"
  Runat="Server">
<Columns>
<asp:BoundColumn 
  DataField="job_entrydate"
  DataFormatString="{0:m}" />
<asp:HyperLinkColumn
  DataTextField="job_briefdesc"
  DataNavigateUrlField="job_id" 
  DataNavigateUrlFormatString="/aspnetjobs/site/job.aspx?id={0}" />
</Columns>
</asp:DataGrid>
</asp:Panel>

</td></tr>
</table>
</form>

<myControls:Footer
  Runat="Server" />