<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script runat="Server">

Sub Page_Load
  If Not IsPostBack Then
    dgrdNewJobs.DataSource = GetNewJobs()
    dgrdNewResumes.DataSource = GetNewResumes() 
    DataBind()
    lblListingCount.Text = _
      String.Format( _
        "Over {0} jobs and {1} resumes listed!", _
        GetJobCount(), GetResumeCount() )
  End If
End Sub    

Function GetNewJobs() As DataSet
  Dim strConString As String
  Dim conJobs As SqlConnection
  Dim dadJobs As SqlDataAdapter
  Dim dstJobs As DataSet

  dstJobs = Cache( "NewJobs" )
  If dstJobs Is Nothing Then
    ' Ready Database Connection
    strConString = ConfigurationSettings.AppSettings( "constring" )
    conJobs = New SqlConnection( strConString )
    dstJobs = New DataSet()
    ' Get Newest 50 Jobs From Database
    dadJobs = New SqlDataAdapter( "getNewJobs", conJobs )
    dadJobs.SelectCommand.CommandType = CommandType.StoredProcedure
    dadJobs.Fill( dstJobs, "NewJobs" )
    Cache( "NewJobs" ) = dstJobs
  End If
  Return dstJobs
End Function

Function GetNewResumes() As DataSet
  Dim strConString As String
  Dim conJobs As SqlConnection
  Dim dadResumes As SqlDataAdapter
  Dim dstResumes As DataSet

  dstResumes = Cache( "NewResumes" )
  If dstResumes Is Nothing Then
    ' Ready Database Connection
    strConString = ConfigurationSettings.AppSettings( "constring" )
    conJobs = New SqlConnection( strConString )
    dstResumes = New DataSet()
    ' Get Newest 50 Resumes From Database
    dadResumes = New SqlDataAdapter( "getNewResumes", conJobs )
    dadResumes.SelectCommand.CommandType = CommandType.StoredProcedure
    dadResumes.Fill( dstResumes, "NewResumes" )
    Cache( "NewResumes" ) = dstResumes
  End If
  Return dstResumes
End Function

Function GetJobCount() As Integer
  Dim strConString As String
  Dim conJobs As SqlConnection
  Dim cmdSelect As SqlCommand
  Dim intJobCount As Integer
  
  intJobCount = Cache( "jobCount" )
  If intJobCount = Nothing Then
    strConString = ConfigurationSettings.AppSettings( "constring" )
    conJobs = New SqlConnection( strConString )
    cmdSelect = New SqlCommand( "getJobCount", conJobs )
    cmdSelect.CommandType = CommandType.StoredProcedure
    conJobs.Open()
      intJobCount = cmdSelect.ExecuteScalar()
    conJobs.Close()
    Cache.Insert( _
      "jobCount", _
       intJobCount, _
       Nothing, _
       DateTime.Now.AddMinutes( 10 ), _
       Timespan.Zero )
  End If
  Return intJobCount
End Function

Function GetResumeCount() As Integer
  Dim strConString As String
  Dim conJobs As SqlConnection
  Dim cmdSelect As SqlCommand
  Dim intResumeCount As Integer
  
  intResumeCount = Cache( "resumeCount" )
  If intResumeCount = Nothing Then
    strConString = ConfigurationSettings.AppSettings( "constring" )
    conJobs = New SqlConnection( strConString )
    cmdSelect = New SqlCommand( "getResumeCount", conJobs )
    cmdSelect.CommandType = CommandType.StoredProcedure
    conJobs.Open()
      intResumeCount = cmdSelect.ExecuteScalar()
    conJobs.Close
    Cache.Insert( _
      "resumeCount", _
       intResumeCount, _
       Nothing, _
       DateTime.Now.AddMinutes( 10 ), _
       Timespan.Zero )
  End If
  Return intResumeCount
End Function

Sub NewJobsPage( s As Object, e As DataGridPageChangedEventArgs )
  dgrdNewJobs.CurrentPageIndex = e.NewPageIndex  
  dgrdNewJobs.Datasource = getNewJobs()
  dgrdNewJobs.DataBind()
End Sub

Sub NewResumesPage( s As Object, e As DataGridPageChangedEventArgs )
  dgrdNewResumes.CurrentPageIndex = e.NewPageIndex  
  dgrdNewResumes.Datasource = getNewResumes()
  dgrdNewResumes.DataBind()
End Sub

</Script>

<asp:Label
  ID="lblListingCount"
  CssClass="TopHeading"
  Runat="Server"/>
<p>
<b>Newest Jobs!</b>
<br>
<asp:DataGrid
  ID="dgrdNewJobs"
  AllowPaging="True"
  OnPageIndexChanged="NewJobsPage"
  PageSize="5"
  PagerStyle-HorizontalAlign="Right"
  PagerStyle-Font-Name="Georgia"
  GridLines="None"
  Cellspacing="4"
  AutoGenerateColumns="False"
  ShowHeader="False"
  Runat="Server">
<Columns>
<asp:BoundColumn
  DataField="job_entrydate"
  DataFormatString="{0:m}" />
<asp:HyperLinkColumn
  DataTextField="job_briefdesc"
  DataNavigateUrlField="job_id" 
  DataNavigateUrlFormatString="/aspnetjobs/site/job.aspx?id={0}"/>
</Columns>
</asp:DataGrid>
<p>

<b>Newest Resumes!</b>
<br>
<asp:DataGrid
  ID="dgrdNewResumes"
  AllowPaging="True"
  OnPageIndexChanged="NewResumesPage"
  PageSize="5"
  PagerStyle-HorizontalAlign="Right"
  PagerStyle-Font-Name="Georgia"
  GridLines="None"
  Cellspacing="4"
  AutoGenerateColumns="False"
  ShowHeader="False"
  Runat="Server">
<Columns>
<asp:BoundColumn
  DataField="ul_entrydate"
  DataFormatString="{0:m}" />
<asp:HyperLinkColumn
  DataTextField="ul_briefdesc"
  DataNavigateUrlField="ul_username" 
  DataNavigateUrlFormatString="/aspnetjobs/{0}.aspx"/>
</Columns>
</asp:DataGrid>
