<%@ Page Language="C#" %>
<%@ Register TagPrefix="myControls" TagName="Address" Src="~/UserControls/Address.ascx" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<!-- #include virtual="~/includes/header.aspx" -->

<script language="C#" runat=server>

void Page_Load(Object sender , EventArgs e) 
{

  if (! IsPostBack )
  {
    ViewState[ "Category" ] = Context.Items[ "Category" ];
  }

  if ( chkSameAddress.Checked )
  {
    ctrlBillingAddress.Validate = false;
  } else {
    ctrlBillingAddress.Validate= true;
  }
}

void btnPlaceOrder_Click( object s, EventArgs e ) {
   string  strUserID;
   string  strConString;
   SqlConnection conMyData;
   SqlCommand cmdOrders;
   SqlParameter parmOrders;

  if ( IsValid ) {

  // Retrieve the UserID
  strUserID = Request.Cookies[ "StoreUserID" ].Value;

  // Copy shipping address to billing
  if ( chkSameAddress.Checked )
  {
    ctrlBillingAddress.Street = ctrlShippingAddress.Street;
    ctrlBillingAddress.City = ctrlShippingAddress.City;
    ctrlBillingAddress.State = ctrlShippingAddress.State;
    ctrlBillingAddress.ZIP = ctrlShippingAddress.ZIP;
  }

  // Create SQL command to execute PlaceOrder stored procedure
  strConString = ConfigurationSettings.AppSettings[ "connectionString" ];
  conMyData = new SqlConnection( strConString );
  cmdOrders = new SqlCommand( "PlaceOrder", conMyData );
  cmdOrders.CommandType = CommandType.StoredProcedure;
  
  // Create a billion parameters
  parmOrders = cmdOrders.Parameters.Add( "@UserID", SqlDbType.UniqueIdentifier );
  parmOrders.Value = new Guid( strUserID );
  cmdOrders.Parameters.Add( "@firstname", txtFirstName.Text );
  cmdOrders.Parameters.Add( "@lastname", txtLastName.Text );
  cmdOrders.Parameters.Add( "@billStreet", ctrlBillingAddress.Street );
  cmdOrders.Parameters.Add( "@billCity", ctrlBillingAddress.City );
  cmdOrders.Parameters.Add( "@billState", ctrlBillingAddress.State );
  cmdOrders.Parameters.Add( "@billZIP", ctrlBillingAddress.ZIP );
  cmdOrders.Parameters.Add( "@shipStreet", ctrlShippingAddress.Street );
  cmdOrders.Parameters.Add( "@shipCity", ctrlShippingAddress.City );
  cmdOrders.Parameters.Add( "@shipState", ctrlShippingAddress.State );
  cmdOrders.Parameters.Add( "@shipZIP", ctrlShippingAddress.ZIP );

  conMyData.Open();
    cmdOrders.ExecuteNonQuery();
  conMyData.Close();

  Response.Redirect( "ThankYou.aspx" )  ;
  }    
}

void btnCancel_Click( object s, EventArgs e ) {
   string  strCategory;

  strCategory = ViewState[ "Category" ].ToString();
  Response.Redirect( string .Format(    "Category.aspx?cat={0}", strCategory ) );
}
</Script>

<html>
<head>
<link href="~/Styles/Store.css" type="text/css" rel="stylesheet" />
<title>Confirm Order</title>
</head>
<body bgcolor="lightblue">
<a href="Default.aspx"><img src="banner.gif" border="1"></a>
<form runat="Server">

<myControls:Tabs
  Runat="Server" />
<table width="800" height="100%" cellpadding="10" 
  cellspacing="0" border="0">
<tr>
  <td width="100%" valign="top" bgcolor="white">

  <div class="formBox">
  <span class="formHeading">Contact Information</span>
  <p>
  Your First Name
  <asp:RequiredFieldValidator
    Text="(required)"
    ControlToValidate="txtFirstName"
    Runat="Server" />
  <br>
  <asp:TextBox
    id="txtFirstName"
    Runat="Server" />
  <p> 
  Your Last Name
  <asp:RequiredFieldValidator
    Text="(required)"
    ControlToValidate="txtLastName"
    Runat="Server" />
  <br>
  <asp:TextBox
    id="txtLastName"
    Runat="Server" />
  </div>
<p>
  <div class="formBox">
  <span class="formHeading">Shipping Information</span>
  <p>
  Shipping Address
  <br>
  <myControls:Address
    id="ctrlShippingAddress"
    Runat="Server" />
  <p> 
  Billing Address
  <br>
  <asp:Checkbox
    id="chkSameAddress"
    Runat="Server" />
  Check here if billing address is same as shipping
  <br>
  <myControls:Address
    id="ctrlBillingAddress"
    Runat="Server" />
  </div>
<p>
  <div>
  <asp:Button
    id="btnCancel"
    Text="Cancel"
    OnClick="btnCancel_Click"
    CausesVaidation="False"
    Runat="Server" />
  &nbsp;&nbsp;&nbsp;
  <asp:Button
    id="btnPlaceOrder"
    OnClick="btnPlaceOrder_Click"
    Text="Place Order!"
    Runat="Server" />
  </div>

  </td>
</tr>
</table>

</form>

<!-- #include virtual="~/includes/footer.aspx" -->
