<%@ Import Namespace="StoreComponents" %>

<Script runat="Server">

Dim intProductID As Integer
Dim intCategory As Integer
Dim strProductName As String
Dim decUnitPrice As Decimal
Dim objShoppingCart As ShoppingCart

Sub Page_Load
  intProductID = Context.Items( "ProductID" )
  intCategory = Context.Items( "Category" )
  strProductName = Context.Items( "ProductName" )
  decUnitPrice = Context.Items( "UnitPrice" )

  objShoppingCart = New ShoppingCart

  If Not IsPostBack Then
    If intProductID = -1 Then
      btnAdd.Visible = False
    End If
    BindDataGrid
  End If
End Sub  

Sub Page_PreRender
  If objShoppingCart.Items.Count = 0 Then
    btnCheckOut.Visible = False
  Else 
    btnCheckOut.Visible = True
    btnCheckOut.NavigateUrl = String.Format( _
      "/aspnetstore/CheckOut.aspx?cat={0}", intCategory )
  End If
End Sub


Sub btnAdd_Click( s As Object, e As EventArgs )
  objShoppingCart.Add( intProductID, strProductName, decUnitPrice )
  BindDataGrid
End Sub

Sub LinkButton_Click( s As Object, e As DataGridCommandEventArgs )
  objShoppingCart.Remove( e.Item.ItemIndex )
  BindDataGrid
End Sub

Sub BindDataGrid
  dgrdShoppingCart.DataSource = objShoppingCart.Items
  dgrdShoppingCart.DataBind()
End Sub
</Script>

<table>
<tr>
  <td>
  <font face="Arial" size="3">
   Your Shopping Cart
  </font>
  </td>
</tr>
<tr>
  <td>
<asp:DataGrid
  id="dgrdShoppingCart"
  OnItemCommand="LinkButton_Click"
  AutoGenerateColumns="False"
  GridLines="Horizontal"
  BackColor="White"
  BorderStyle="Solid"
  BorderColor="Black"
  BorderWidth="2"
  Width="200"
  CellPadding="4"
  Font-Face="Arial"
  Font-Size="10pt"
  HeaderStyle-Font-Face="Arial"
  HeaderStyle-Font-Size="10pt"
  HeaderStyle-BackColor="orange"
  Runat="Server">
<Columns>
  <asp:TemplateColumn>
    <ItemTemplate>
    <asp:LinkButton
      Text="x"
      Style="color:red;font:bold 12pt Arial;text-decoration:none"
      Runat="Server" />
    </ItemTemplate>
  </asp:TemplateColumn> 
  <asp:BoundColumn
    DataField="ProductName" 
    HeaderText="item" />
  <asp:BoundColumn
    DataField="UnitPrice"
    DataFormatString="{0:c}" 
    HeaderText="price" />
  <asp:BoundColumn
    DataField="Quantity"
    HeaderText="qty" />
</Columns>
</asp:DataGrid>
  </td>
</tr>
<tr>
  <td align="right">
  Total: 
  <%=String.Format( "{0:c}", objShoppingCart.GetItemTotal() )%>
  </td>
</tr>
<tr>
  <td align="right">
  <asp:LinkButton
    id="btnAdd"
    Text="Add to Cart"
    OnClick="btnAdd_Click"
    Runat="Server" />
  &nbsp;&nbsp;
  <asp:HyperLink
    id="btnCheckOut"
    Text="Check Out"
    Runat="Server" />
  </td>
</tr>
</table>
  